# Helm chart for k8s-capi-provider

This Helm chart deploys k8s-capi-provider in k8s cluster.

## Deployment

Prerequisites

* [Helm](https://helm.sh/)

```bash
helm repo add k8s-capi-provider https://gitlab.com/api/v4/projects/31045539/packages/helm/stable
helm install k8s-capi-provider k8s-capi-provider/k8s-capi-provider
```
## Local deployment using KinD (Kubernetes in Docker)

Prerequisites

* [Helm](https://helm.sh/)
* [Kind](https://kind.sigs.k8s.io/)

1. Create KinD cluster
```bash
kind create cluster
```
2. Review the default helm chart values

3. Deploy k8s-capi-provider
```bash
helm install k8s-capi-provider chart
```

## Configuration

The following table lists the configurable parameters of the K8s-capi-provider chart and their default values.

| Parameter                | Description             | Default        |
| ------------------------ | ----------------------- | -------------- |
| `nameOverride` | Override the default value of 'app' label used by k8s objects | `""` |
| `namespaceOverride` | Override the deployment namespace | `""` |
| `fullnameOverride` | Provide a name to substitute for the full names of resources | `""` |
| `commonLabels` | Labels to apply to all resources | `{}` |
| `baseCtrl.image.repository` | Overrides the image repository | `"registry.gitlab.com/yaook/incubator/k8s-capi-provider"` |
| `baseCtrl.image.pullPolicy` | Overrides the image pullPolicy | `"IfNotPresent"` |
| `baseCtrl.image.tag` | Overrides the image tag | `"latest"` |
| `baseCtrl.image.command` | Overrides the image command | `[]` |
| `baseCtrl.image.args` | Overrides the image arguments | `[]` |
| `baseCtrl.image.pullSecrets` | Overrides the image pullSecrets | `[]` |
| `baseCtrl.image.securityContext.capabilities.add` |  | `["NET_ADMIN", "SYS_ADMIN"]` |
| `baseCtrl.rbacAuthorization.clusterRole.enabled` |  | `true` |
| `baseCtrl.rbacAuthorization.clusterRoleBinding.enabled` |  | `true` |
| `baseCtrl.rbacAuthorization.serviceAccount.enabled` |  | `true` |
| `baseCtrl.rbacAuthorization.serviceAccount.annotations` | Annotations to add to the service account | `{}` |
| `baseCtrl.podAnnotations.container.apparmor.security.beta.kubernetes.io/k8s-capi-provider` |  | `"unconfined"` |
| `baseCtrl.podSecurityContext` | Set security context of pods | `{}` |
| `baseCtrl.resources` | Set resources of pod | `{}` |
| `baseCtrl.nodeSelector` | Set node selectors of pod | `{}` |
| `baseCtrl.tolerations` | Set tolerations of pod | `[]` |
| `baseCtrl.affinity` | Set affinity of pod | `{}` |
| `clusterCtrl.image.args` | Cluster controller args | `["run", "--all-namespaces", "--standalone", "-m", "src.controllers.cluster.run"]` |
| `clusterCtrl.image.repository` |  | `"registry.gitlab.com/yaook/incubator/k8s-capi-provider"` |
| `clusterCtrl.image.pullPolicy` |  | `"IfNotPresent"` |
| `clusterCtrl.image.tag` |  | `"latest"` |
| `clusterCtrl.image.command` |  | `[]` |
| `clusterCtrl.image.pullSecrets` |  | `[]` |
| `clusterCtrl.image.securityContext.capabilities.add` |  | `["NET_ADMIN", "SYS_ADMIN"]` |
| `clusterCtrl.rbacAuthorization.clusterRole.enabled` |  | `true` |
| `clusterCtrl.rbacAuthorization.clusterRoleBinding.enabled` |  | `true` |
| `clusterCtrl.rbacAuthorization.serviceAccount.enabled` |  | `true` |
| `clusterCtrl.rbacAuthorization.serviceAccount.annotations` | Annotations to add to the service account | `{}` |
| `clusterCtrl.podAnnotations.container.apparmor.security.beta.kubernetes.io/k8s-capi-provider` |  | `"unconfined"` |
| `clusterCtrl.podSecurityContext` |  | `{}` |
| `clusterCtrl.resources` |  | `{}` |
| `clusterCtrl.nodeSelector` |  | `{}` |
| `clusterCtrl.tolerations` |  | `[]` |
| `clusterCtrl.affinity` |  | `{}` |
| `serviceCtrl.image.args` | Service controller args | `["run", "--all-namespaces", "--standalone", "-m", "src.controllers.service.run"]` |
| `serviceCtrl.image.repository` |  | `"registry.gitlab.com/yaook/incubator/k8s-capi-provider"` |
| `serviceCtrl.image.pullPolicy` |  | `"IfNotPresent"` |
| `serviceCtrl.image.tag` |  | `"latest"` |
| `serviceCtrl.image.command` |  | `[]` |
| `serviceCtrl.image.pullSecrets` |  | `[]` |
| `serviceCtrl.image.securityContext.capabilities.add` |  | `["NET_ADMIN", "SYS_ADMIN"]` |
| `serviceCtrl.rbacAuthorization.clusterRole.enabled` |  | `true` |
| `serviceCtrl.rbacAuthorization.clusterRoleBinding.enabled` |  | `true` |
| `serviceCtrl.rbacAuthorization.serviceAccount.enabled` |  | `true` |
| `serviceCtrl.rbacAuthorization.serviceAccount.annotations` | Annotations to add to the service account | `{}` |
| `serviceCtrl.podAnnotations.container.apparmor.security.beta.kubernetes.io/k8s-capi-provider` |  | `"unconfined"` |
| `serviceCtrl.podSecurityContext` |  | `{}` |
| `serviceCtrl.resources` |  | `{}` |
| `serviceCtrl.nodeSelector` |  | `{}` |
| `serviceCtrl.tolerations` |  | `[]` |
| `serviceCtrl.affinity` |  | `{}` |

---

_Configuration is generated by [Frigate](https://frigate.readthedocs.io):_
```bash
pip install frigate
frigate gen chart/ --no-deps
```
